OpenAPI SpecificationJSON
API Reference

Workflow Step

A workflow step object defines individual steps within a workflow that control the approval process for annotations. Each step has a specific type, mode, and condition that determines how the workflow progresses.

Currently, the only supported step type is approval, which requires designated assignees to approve annotations before they can proceed in the workflow.

Workflow step

Attribute
Type
Description
id*
read-only
integer

ID of the workflow step

name*
string

Name of the workflow step

url*
read-only
URL

URL of the workflow step

organization*
URL

Organization URL.

workflow*
URL

URL of the workflow

condition*
object

Condition that designates whether the workflow step will be entered

type*
"approval"

Type of the workflow step (currently the only supported value is approval)

Default: "approval"
mode*
"any" | "all" | "auto"

Supported values:

  • any - approval of one assignee is enough
  • all - all assignees must approve
  • auto - automatically approved if the condition matches
ordering*
integer

Designates the evaluation order of steps within a workflow (must be unique per a workflow)

List workflow steps

GET api / v1 / workflow_steps

Retrieve all workflow step objects.

GET
/api/v1/workflow_steps
curl -X GET "https://example.rossum.app/api/v1/workflow_steps"
{
  "pagination": {
    "next": null,
    "previous": null
  },
  "results": [
    {
      "id": 7540,
      "name": "Team Lead approval step",
      "url": "https://example.rossum.app/api/v1/workflow_steps/7540",
      "organization": "https://example.rossum.app/api/v1/organizations/406",
      "workflow": "https://example.rossum.app/api/v1/workflows/7540",
      "condition": {},
      "type": "approval",
      "mode": "all",
      "ordering": 1
    }
  ]
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Response

200OK

OK

Attribute
Type
Description
pagination*
pagination
next
URL

URL for the next page of results. Contains an opaque signed cursor query parameter. Use this URL directly to fetch the next page — do not attempt to construct or modify the cursor value.

previous
URL

URL for the previous page of results. Contains an opaque signed cursor query parameter. Use this URL directly to fetch the previous page — do not attempt to construct or modify the cursor value.

results*
id*
read-only
integer

ID of the workflow step

name*
string

Name of the workflow step

url*
read-only
URL

URL of the workflow step

organization*
URL

Organization URL.

workflow*
URL

URL of the workflow

condition*
object

Condition that designates whether the workflow step will be entered

type*
"approval"

Type of the workflow step (currently the only supported value is approval)

Default: "approval"
mode*
"any" | "all" | "auto"

Supported values:

  • any - approval of one assignee is enough
  • all - all assignees must approve
  • auto - automatically approved if the condition matches
ordering*
integer

Designates the evaluation order of steps within a workflow (must be unique per a workflow)

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

Retrieve workflow step

GET api / v1 / workflow_steps / {workflowStepID}

Get a workflow step object.

GET
/api/v1/workflow_steps/{workflowStepID}
curl -X GET "https://example.rossum.app/api/v1/workflow_steps/0"
{
  "id": 7540,
  "name": "Team Lead approval step",
  "url": "https://example.rossum.app/api/v1/workflow_steps/7540",
  "organization": "https://example.rossum.app/api/v1/organizations/406",
  "workflow": "https://example.rossum.app/api/v1/workflows/7540",
  "condition": {},
  "type": "approval",
  "mode": "all",
  "ordering": 1
}
{
  "detail": "Bad Request.",
  "code": "bad_request"
}
{
  "detail": "Invalid token.",
  "code": "authentication_failed"
}
{
  "detail": "Access to the requested resource is forbidden.",
  "code": "access_forbidden"
}
{
  "detail": "Not found.",
  "code": "not_found"
}
{
  "detail": "Conflict.",
  "code": "conflict_status"
}
{
  "detail": "Request was rate limited.",
  "code": "rate_limited",
  "url": "https://rossum.app/api/docs/openapi/guides/overview/#rate-limiting"
}
{
  "detail": "Server error.",
  "code": "error"
}
{
  "detail": "Bad Gateway.",
  "code": "bad_gateway"
}
{
  "detail": "Service Unavailable.",
  "code": "service_unavailable"
}
{
  "detail": "Gateway timeout.",
  "code": "gateway_timeout"
}

Response

200OK

OK

Attribute
Type
Description
id*
read-only
integer

ID of the workflow step

name*
string

Name of the workflow step

url*
read-only
URL

URL of the workflow step

organization*
URL

Organization URL.

workflow*
URL

URL of the workflow

condition*
object

Condition that designates whether the workflow step will be entered

type*
"approval"

Type of the workflow step (currently the only supported value is approval)

Default: "approval"
mode*
"any" | "all" | "auto"

Supported values:

  • any - approval of one assignee is enough
  • all - all assignees must approve
  • auto - automatically approved if the condition matches
ordering*
integer

Designates the evaluation order of steps within a workflow (must be unique per a workflow)

400Bad Request

Invalid input data.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

401Unauthorized

The username/password is invalid or token is invalid (e.g. expired).

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

403Forbidden

Insufficient permission, missing authentication, invalid CSRF token and similar issue.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

404Not Found

The specified resource was not found.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

409Conflict

Conflict

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

429Too Many Requests

Request rate is too high, wait before sending more requests. See Rate Limiting for more details.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

url
read-only
string

Link to the rate limiting documentation

500Internal Server Error

Server failure while processing the request.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

502Bad Gateway

Invalid response from the upstream server.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

503Service Unavailable

We're temporarily offline for maintenance. Please try again later.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error

504

Upstream server could not complete the request in time.

Attribute
Type
Description
detail
read-only
string

Detail of the error

code
read-only
string

Code of the error